/*
 * Copyright 2020 Digi Dinos JSC. All rights reserved.
 * Email: tech@digidinos.com.
 */

/**
 * SCSS styles
 */

// Web fonts
@import url('https://fonts.googleapis.com/css?family=Noto+Serif+JP:400,700&display=swap&subset=japanese');

// If you want to override variables do it here
@import "variables";

// Mixins
@import "mixins";

// Import styles
@import "~@coreui/coreui/scss/coreui";

/* -----------------------------------------------------------
  common
  ----------------------------------------------------------- */
body {
  font-family: $main-font;
  color: $text-color;
}
ul {
  list-style: none;
  padding: 0;
  margin: 0;
}
a,
button,
.btn {
  transition: all 0.4s ease;
}
img {
  max-width: 100%;
}
h1, h2, h3, h4, h5, h6,
.h1, .h2, .h3, .h4, .h5, .h6 {
  font-weight: bold;
}
.over {
  transition: all 0.4s ease;
  &:hover {
    opacity: 0.9;
  }
}
.white-space-nowrap {
  white-space: nowrap !important;
}
.bt-0 {
  border-top: 0 !important;
}
.width-1x {
  width: 14px !important;
}
.mw-9x {
  max-width: 900px;
  margin: auto;
  @include mq(max_lg) {
    max-width: 100%;
  }
}
.text-red {
  color: #f00 !important;
}

/* -----------------------------------------------------------
  layout common
----------------------------------------------------------- */
.c-body {
  flex-direction: column;
}
.c-app {
  color: $text-color;
  background-color: $body-bg-color;
}
.con-main-body {
  padding: 50px 0;
  .user-layout & {
    padding: 10px 0 50px;
  }
}

/* -----------------------------------------------------------
  header
----------------------------------------------------------- */
.c-header {
  height: auto;
  min-height: 0;
  background: transparent;
  border-bottom: 0;
}

.header-main-nav {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  outline: 0;
  background: rgba(#000, 0.3);
  border-bottom: 0;
  transition: all 0.4s ease;
  padding: 20px 0;
  z-index: $z-index-header-fixed;
  @include mq(max_md) {
    padding: 10px 0;
  }
  @include mq(max_sm) {
    position: relative;
    background: #fff;
  }
  &.is-fixed,
  .user-layout & {
    height: $header-fixed-height;
    background: #fff;
    box-shadow: 0 0 5px 2px rgba(0, 0, 0, 0.1);
    padding: 10px 0;
    @include mq(max_sm) {
      position: fixed;
      transform: translate(0, 0);
    }
    .btn-menu {
      .ic {
        > span {
          background: $text-color;
        }
      }
    }
    .logo {
      img {
        height: 46px;
      }
    }
    .main-nav {
      > ul {
        > li {
          &.active > a,
          &:hover > a {
            color: $primary;
          }
          > a {
            color: $text-color;
            padding: 17px 0;
          }
        }
      }
    }
  }
  &.is-hide {
    transform: translate(0, -100%);
  }
  .col-btn-menu {
    display: none;
    text-align: right;
    @include mq(max_md) {
      display: block;
    }
  }
  .col-nav {
    display: flex;
    justify-content: center;
    align-items: center;
  }
  .btn-menu {
    display: none;
    position: relative;
    width: 50px;
    height: 50px;
    background: transparent;
    border: 0;
    outline: 0;
    text-align: center;
    text-decoration: none;
    padding: 0;
    @include mq(max_md) {
      display: inline-block;
      vertical-align: middle;
    }
    .inner_btn {
      display: block;
      position: absolute;
      left: 0;
      top: 50%;
      transform: translate(0, -50%);
      width: 100%;
      line-height: 0;
    }
    .ic {
      display: inline-block;
      vertical-align: middle;
      position: relative;
      width: 33px;
      height: 22px;
      overflow: hidden;
      > span {
        display: inline-block;
        vertical-align: middle;
        position: absolute;
        left: 0;
        height: 2px;
        width: 100%;
        background: #fff;
        @include mq(max_sm) {
          background: $text-color;
        }
        &:nth-of-type(1) {
          top: 0;
        }
        &:nth-of-type(2) {
          top: 10px;
        }
        &:nth-of-type(3) {
          bottom: 0;
        }
      }
    }
  }
  .logo {
    display: inline-block;
    vertical-align: middle;
    img {
      height: 60px;
      transition: all 0.4s ease;
      @include mq(max_md) {
        height: 46px;
      }
    }
  }
  .main-nav {
    position: relative;
    display: table;
    width: auto;
    margin-left: auto;
    margin-right: 0;
    @include mq(max_md) {
      display: none;
    }
    > ul {
      position: relative;
      padding-bottom: 0;
      z-index: 1;
      &:after {
        display: table;
        content: '';
        clear: both;
      }
      > li {
        float: left;
        padding-right: 40px;
        @include mq(max_lg) {
          padding-right: 25px;
        }
        &:last-child {
          padding-right: 0 !important;
        }
        &.active > a,
        &:hover > a {
          color: $primary;
        }
        > a {
          display: block;
          font-size: 16px;
          line-height: 1;
          font-weight: 300;
          color: #fff;
          background: none transparent;
          border: 0 none;
          text-decoration: none;
          white-space: nowrap;
          padding: 10px 0;
        }
      }
    }
  }
}

/* -----------------------------------------------------------
  offcanvas menu
----------------------------------------------------------- */
.header-offcanvas {
  display: none;
  opacity: 0;
  visibility: hidden;
  position: fixed;
  top: 0;
  left: 0;
  right: auto;
  transform: translate(-100%, 0);
  bottom: auto;
  overflow-x: hidden;
  overflow-y: auto;
  -webkit-overflow-scrolling: touch;
  width: 0;
  height: 100vh;
  background: #fff;
  z-index: $z-index-header-offcanvas;
  transition: all 0.4s ease;
  padding: 0;
  margin: 0;
  @include mq(max_md) {
    display: block;
  }
  &.is-visible-offcanvas {
    opacity: 1;
    visibility: visible;
    width: 80%;
    max-width: 440px;
    transform: translate(0, 0);
    &:after {
      visibility: hidden;
      opacity: 0;
      width: 0;
      height: 0;
      transition: width 0.1s 0.2s, height 0.1s 0.2s;
    }
    &.is-removing-offcanvas {
      transform: translate(-100%, 0);
    }
  }
  &:after {
    content: '';
    visibility: visible;
    opacity: 1;
    position: absolute;
    top: 0;
    right: 0;
    width: 100%;
    height: 100%;
    background: transparent;
  }
  .oc-header {
    .btn-close {
      position: absolute;
      right: 0;
      top: 0;
      height: 40px;
      width: 40px;
      font-size: 17px;
      line-height: 1;
      color: #fff;
      background: $primary;
      border: 0 none;
      outline: 0;
      cursor: pointer;
      @include transition(all 0.4s ease);
      padding: 0;
      margin: 0;
      &:active,
      &:hover {
        background: darken($primary, 10%);
      }
    }
  }
  .oc-body {
    padding: 60px 0 50px;
    > * {
      margin-bottom: 40px;
    }
  }
  .main-nav {
    padding: 0;
  }
  .txt-title {
    font-size: 18px;
    padding: 0 30px;
    margin-bottom: 15px;
    @include mq(max_xs) {
      padding: 0 15px;
    }
  }
  .box-nav {
    float: none;
    border-top: 1px solid #e3e3e3;
    padding: 0;
    margin: 0;
    .btn-plus {
      display: flex;
      justify-content: center;
      align-items: center;
      position: absolute;
      right: 0;
      top: 0;
      width: 30px;
      height: 30px;
      font-size: 18px;
      color: #fff;
      font-weight: bold;
      cursor: pointer;
      @include transition(all 0.4s ease);
      &:hover {
        opacity: 0.7;
      }
      &:before {
        content: '+';
      }
      &.active {
        &:before {
          content: '-';
        }
      }
    }
    ul {
      display: none;
      width: auto;
      position: relative;
      left: auto;
      top: auto;
      right: auto;
      bottom: auto;
      box-shadow: none;
      padding-left: 15px;
    }
    li {
      display: block;
      position: relative;
      float: none;
      width: 100%;
      background: none transparent;
      > a {
        display: block;
        width: auto;
        position: relative;
        font-weight: bold;
        font-size: 16px;
        color: $text-color;
        background: transparent;
        border: 0 none;
        text-decoration: none;
        outline: 0;
        border-bottom: 1px solid #e3e3e3;
        padding: 10px 30px;
        @include mq(max_xs) {
          padding: 8px 15px;
        }
      }
    }
    li > a:hover,
    li > a:focus,
    li.active > a {
      color: $primary;
      &:before {
        opacity: 1;
      }
    }
  }
}
.header-offcanvas-overlay {
  visibility: hidden;
  opacity: 0;
  display: block;
  position: fixed;
  right: 0;
  top: 0;
  left: auto;
  bottom: auto;
  width: 100%;
  height: 100%;
  z-index: -9999;
  background: rgba(0, 0, 0, 0.50);
  @include transition(opacity 0.2s ease);
  &.is-visible-offcanvas {
    visibility: visible;
    opacity: 1;
    z-index: $z-index-header-overlay;
    &.is-removing-offcanvas {
      opacity: 0;
    }
  }
}

/* -----------------------------------------------------------
  .con-banner-top
----------------------------------------------------------- */
.con-banner-top {
  display: block;
  position: relative;
  width: 100%;
  height: 450px;
  background: transparent url(../images/img-top-landing-banner.jpg) no-repeat center center;
  background-size: cover;
  @include mq(max_md) {
    height: 400px;
  }
  @include mq(max_sm) {
    height: auto;
    padding-bottom: 86%;
  }
  .user-layout & {
    height: 160px;
    background: url(../images/img-top-user-banner.jpg);
    @include mq(max_sm) {
      padding-bottom: 27%;
    }
    @include mq(max_xs) {
      padding-bottom: 46%;
    }
  }
  .box-title {
    position: absolute;
    top: 50%;
    left: 0;
    width: 100%;
    padding: 0 2.5%;
    z-index: 1;
    @include mq(max_sm) {
      transform: translate(0, -50%);
    }
    .user-layout & {
      transform: translate(0, -50%);
    }
    .title-page {
      display: table;
      min-width: 400px;
      font-weight: bold;
      font-size: 30px;
      color: #fff;
      text-align: center;
      background: rgba(#000, 0.38);
      padding: 15px 30px;
      margin: auto;
      @include mq(max_sm) {
        font-size: 26px;
      }
      @include mq(max_xs) {
        min-width: 0;
        font-size: 22px;
      }
    }
  }
}

/* -----------------------------------------------------------
  Footer
----------------------------------------------------------- */
.c-footer {
  display: block;
  height: auto;
  color: #fff;
  background: #212529;
  border: 0;
  padding: 50px 0;
  .main-nav {
    margin-bottom: 30px;
    ul {
      text-align: center;
      li {
        display: inline-block;
        vertical-align: middle;
        padding: 0 10px;
        a {
          display: block;
          position: relative;
          color: #fff;
          text-align: center;
          text-decoration: none;
          padding: 0 0 5px;
          &:hover {
            &:after {
              width: 100%;
            }
          }
          &:after {
            display: block;
            content: '';
            position: absolute;
            left: 50%;
            bottom: 0;
            transform: translate(-50%, 0);
            width: 0;
            height: 3px;
            background: #fff;
            transition: all 0.4s ease;
          }
        }
      }
    }
  }
  .box-copyright {
    text-align: center;
    .powered-by {
      font-size: 0.86em;
    }
  }
}

/* -----------------------------------------------------------
  Heading common
----------------------------------------------------------- */
.st-lg {
  margin-bottom: 20px;
  .lg {
    display: block;
    position: relative;
    font-size: 36px;
    color: $text-color;
    font-weight: bold;
    text-align: center;
    padding-bottom: 0.6em;
    margin: 0;
    @include mq(max_md) {
      font-size: 32px;
    }
    @include mq(max_sm) {
      font-size: 28px;
    }
    @include mq(max_xs) {
      font-size: 22px;
    }
    &:after {
      display: block;
      content: "";
      position: absolute;
      bottom: 0;
      left: 50%;
      transform: translate(-50%, 0);
      width: 100%;
      max-width: 80px;
      height: 3px;
      background: $text-color;
    }
    &.left {
      text-align: left;
    }
    &.right {
      text-align: right;
    }
  }

  .md {
    display: block;
    position: relative;
    font-size: 30px;
    color: $text-color;
    font-weight: normal;
    text-align: center;
    margin: 0;
    @include mq(max_md) {
      font-size: 26px;
    }
    @include mq(max_sm) {
      font-size: 22px;
    }
    &.left {
      text-align: left;
    }
    &.right {
      text-align: right;
    }
  }
}

/* -----------------------------------------------------------
  Sidebar
----------------------------------------------------------- */
.main-sidebar-content {
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  .main-sidebar {
    flex: 0 0 280px;
    @include mq(max_xl) {
      width: 25%;
    }
    @include mq(max_md) {
      display: none;
    }
  }
  .main-content {
    flex-grow: 1;
    padding-left: 20px;
    @include mq(max_xl) {
      width: 25%;
    }
  }
  .main-sidebar,
  .main-content {
    > * {
      @include mq(max_md) {
        width: 100%;
      }
      &:last-child {
        margin-bottom: 0;
      }
    }
  }
}

.main-sidebar {
  .txt-title {
    font-size: 18px;
    margin-bottom: 20px;
  }
  .box-nav {
    li {
      border-bottom: 1px solid #d8dbe0;
      padding-bottom: 10px;
      margin-bottom: 10px;
      &:last-child {
        border-bottom: 0;
        padding-bottom: 0;
        margin-bottom: 0;
      }
      a {
        color: $text-color;
        font-weight: bold;
        text-decoration: none;
        &:hover {
          color: $primary;
        }
      }
    }
  }
}

/* -----------------------------------------------------------
  User layout
----------------------------------------------------------- */
.c-app:not(.user-layout) {
  font-size: 16px;
  @include mq(max_sm) {
    font-size: 15px;
  }
  .card-body {
    @include mq(md) {
      padding: 40px;
    }
  }
}

.user-layout {
  padding-top: $header-fixed-height;
}

/* -----------------------------------------------------------
  Breadcrumb
----------------------------------------------------------- */
.breadcrumb-item {
  &.active {
    color: $text-color;
  }
  & + &::before {
    color: $text-color;
  }
}

/* -----------------------------------------------------------
  Button common
----------------------------------------------------------- */
.btn {
  .c-icon {
    margin: 0;
  }
}

.btn-xl,
.btn-group-xl > .btn {
  min-width: 160px;
  font-size: 1.09375rem;
  line-height: 1.5;
  border-radius: 0.3rem;
  padding: 0.75rem 2rem;
  @include mq(max_xl) {
    padding: 0.75rem 1rem;
  }
}

/* -----------------------------------------------------------
  Form common
----------------------------------------------------------- */
.form-2-col {
  .col-form-label {
    text-align: right;
    @include mq(max_md) {
      text-align: left;
    }
  }
}
.custom-file {
  &-input {
    cursor: pointer;
  }
  &-label {
    left: 5px;
    right: 5px;
  }
}
.custom-checkbox {
  .custom-control-label {
    cursor: pointer;
  }
}
.custom-radio {
  .custom-control-label {
    cursor: pointer;
  }
}
.input-group-append {
  .btn {
    border: 0;
  }
}
.input-group-prepend {
  height: calc(1.5em + 0.75rem + 2px);
}
.custom-prepend-textarea {
  .input-group-prepend {
    height: auto;
  }
}

/* -----------------------------------------------------------
  Main control
----------------------------------------------------------- */
.main-control {
  display: flex;
  justify-content: space-between;
  align-items: center;
  @include mq(max_sm) {
    flex-direction: column;
  }
  .app-sort {
    display: flex;
    align-items: center;
    .form-control {
      width: auto;
    }
  }
  .app-sort,
  .app-pagination {
    @include mq(max_sm) {
      margin-right: 0;
      margin-left: auto;
    }
  }
}

/* -----------------------------------------------------------
  Table common
----------------------------------------------------------- */
.table {
  thead {
    tr {
      th {
        white-space: nowrap;
      }
    }
  }
  .btn-sm {
    svg[class*="fa"] {
      width: 12px;
    }
  }
}

/* -----------------------------------------------------------
  Card common
----------------------------------------------------------- */
.card {
  &-header {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    align-items: center;
    white-space: normal;
    &-actions {
      float: none;
    }
  }
  &-footer {
    text-align: center;
    .btn {
      min-width: 100px;
      margin: 0.25rem;
    }
  }
}

/* -----------------------------------------------------------
  modal common
----------------------------------------------------------- */
.modal-xxl {
  .modal-dialog {
    @include mq(lg) {
      width: 98%;
      max-width: 1000px;
    }
    @include mq(xl) {
      width: 95%;
      max-width: 1200px;
    }
  }
}

/* -----------------------------------------------------------
  loading
  ----------------------------------------------------------- */
.loading-parent--relative {
  position: relative;
}

.loading-parent--hidden {
  overflow: hidden;
}
